org.apache.hc.core5.http.nio.support

## Class BasicRequestProducer

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.BasicRequestProducer

- All Implemented Interfaces:
    AsyncDataProducer, AsyncRequestProducer, ResourceHolder

      public class BasicRequestProducer
      extends Object
      implements AsyncRequestProducer

  Basic implementation of `AsyncRequestProducer` that produces one fixed request and relies on a `AsyncEntityProducer` to generate request entity stream.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicRequestProducer(HttpRequest request, AsyncEntityProducer dataProducer)`
    `BasicRequestProducer(Method method, HttpHost host, String path)`
    `BasicRequestProducer(Method method, HttpHost host, String path, AsyncEntityProducer dataProducer)`
    `BasicRequestProducer(Method method, URI requestUri)`
    `BasicRequestProducer(Method method, URI requestUri, AsyncEntityProducer dataProducer)`
    `BasicRequestProducer(String method, HttpHost host, String path)`
    `BasicRequestProducer(String method, HttpHost host, String path, AsyncEntityProducer dataProducer)`
    `BasicRequestProducer(String method, URI requestUri)`
    `BasicRequestProducer(String method, URI requestUri, AsyncEntityProducer dataProducer)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes immediately available for output.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data generation.
    `boolean` | `isRepeatable()` Tests whether the producer can consistently produce the same content after invocation of `ResourceHolder.releaseResources()`.
    `void` | `produce(DataStreamChannel channel)` Triggered to signal the ability of the underlying data channel to accept more data.
    `void` | `releaseResources()`
    `void` | `sendRequest(RequestChannel requestChannel, HttpContext httpContext)` Triggered to signal the ability of the underlying request channel to accept a request messages.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BasicRequestProducer

          public BasicRequestProducer(HttpRequest request,
                                      AsyncEntityProducer dataProducer)

    - #### BasicRequestProducer

          public BasicRequestProducer(String method,
                                      HttpHost host,
                                      String path,
                                      AsyncEntityProducer dataProducer)

    - #### BasicRequestProducer

          public BasicRequestProducer(String method,
                                      HttpHost host,
                                      String path)

    - #### BasicRequestProducer

          public BasicRequestProducer(String method,
                                      URI requestUri,
                                      AsyncEntityProducer dataProducer)

    - #### BasicRequestProducer

          public BasicRequestProducer(String method,
                                      URI requestUri)

    - #### BasicRequestProducer

          public BasicRequestProducer(Method method,
                                      HttpHost host,
                                      String path,
                                      AsyncEntityProducer dataProducer)

    - #### BasicRequestProducer

          public BasicRequestProducer(Method method,
                                      HttpHost host,
                                      String path)

    - #### BasicRequestProducer

          public BasicRequestProducer(Method method,
                                      URI requestUri,
                                      AsyncEntityProducer dataProducer)

    - #### BasicRequestProducer

          public BasicRequestProducer(Method method,
                                      URI requestUri)

  - ### Method Detail

    - #### sendRequest

          public void sendRequest(RequestChannel requestChannel,
                                  HttpContext httpContext)
                           throws HttpException,
                                  IOException

      Description copied from interface: `AsyncRequestProducer`
      Triggered to signal the ability of the underlying request channel to accept a request messages. The data producer can choose to send a request message immediately inside the call or asynchronously at some later point.
      Specified by:
        `sendRequest` in interface `AsyncRequestProducer`
      Parameters:
        `requestChannel` - the request channel capable to accepting a request message.
        `httpContext` - the actual execution context.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### available

          public int available()

      Description copied from interface: `AsyncDataProducer`
      Returns the number of bytes immediately available for output. This method can be used as a hint to control output events of the underlying I/O session.

      Please note this method should return zero if the data producer is unable to produce any more data, in which case `AsyncDataProducer.produce(DataStreamChannel)` method will not get triggered. The producer can resume writing out data asynchronously once more data becomes available or request output readiness events with `DataStreamChannel.requestOutput()`.

      Specified by:
        `available` in interface `AsyncDataProducer`
      Returns:
        the number of bytes immediately available for output
      See Also:
        `AsyncDataProducer.produce(DataStreamChannel)`, `DataStreamChannel.requestOutput()`

    - #### produce

          public void produce(DataStreamChannel channel)
                       throws IOException

      Description copied from interface: `AsyncDataProducer`
      Triggered to signal the ability of the underlying data channel to accept more data. The data producer can choose to write data immediately inside the call or asynchronously at some later point.

      Please note this method gets triggered only if `AsyncDataProducer.available()` returns a positive value.

      Specified by:
        `produce` in interface `AsyncDataProducer`
      Parameters:
        `channel` - the data channel capable of accepting more data.
      Throws:
        `IOException` - in case of an I/O error.
      See Also:
        `AsyncDataProducer.available()`

    - #### isRepeatable

          public boolean isRepeatable()

      Description copied from interface: `AsyncRequestProducer`
      Tests whether the producer can consistently produce the same content after invocation of `ResourceHolder.releaseResources()`.
      Specified by:
        `isRepeatable` in interface `AsyncRequestProducer`

    - #### failed

          public void failed(Exception cause)

      Description copied from interface: `AsyncRequestProducer`
      Triggered to signal a failure in data generation.
      Specified by:
        `failed` in interface `AsyncRequestProducer`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.